/*rexx comment*/
/*trace on*/
/*
 *  RxBonk (c) Copyright 1995 by:       
 *             Lionel Widdifield and S.C.S. Inc.             
 *             P.O. Box 8406                       
 *             Victoria BC Canada V8W 3S1                
 *                                                                        
 *    All rights reserved.  Unauthorized distribution prohibited.
 *
 *    This is a demo application to exercise the version7 lookup
 *    and rexx simple windowing dlls.
 *
 */



 /* To install, simply edit the following 2 lines               */
 /* config.v7dir = drive:path of the compiled version7 nodelist */
 /* config.addr  = stating node address                         */
  
 config.v7dir = 'g:\bink\node\'
 config.addr  = '1:340/0'


/***************************************************/

 call LoadAllDlls
 sizes = RxWinInitialize(1)
 parse var sizes config.rows config.cols

 call RxWinClearScreen 0, 0
 clr.Txt = 30
 clr.FWD = clr.Txt + 1


 if config.rows < 25 then signal FastExit
 if config.cols < 80 then signal FastExit
 
 hWnd.0 = 1
 hWnd.1 = RxWinCreateWindow(1, 1, config.cols, config.rows, clr.Txt, 4, clr.Txt, 0)
 call RxWinCenterText hWnd.1, 1, 'hWnd.1 = '||hWnd.1, clr.Txt


 s.data.0 = 12
 s.data.1.row = 2
 s.data.1.col = 2
 s.data.1.txt = 'N)ode-Order.:'
 s.data.1.fdw = 7
 
 node.order   = 1
 node.order.1 = 'ByAddr'
 node.param.1 = 'Node'
 node.order.2 = 'BySysop'
 node.param.2 = 'Sysop'

 s.data.2.row = 4
 s.data.2.col = 2
 s.data.2.txt = 'A)ddr.........:'
 s.data.2.fdw = 18
 
 s.data.3.row = 4
 s.data.3.col = (s.data.2.col+s.data.2.fdw+length(s.data.2.txt))
 s.data.3.txt = 'H)ub:'
 s.data.3.fdw = 5
 
 s.data.4.row = 4
 s.data.4.col = s.data.3.col+10
 s.data.4.txt = 'P)asswd:'
 s.data.4.fdw = 9+2

 s.data.5.row = 5
 s.data.5.col = 2
 s.data.5.txt = 'S)ystem Title.:'
 s.data.5.fdw = 40

 s.data.6.row = 6
 s.data.6.col = 2
 s.data.6.txt = 'O)perator.....:'
 s.data.6.fdw = 40
 
 s.data.7.row = 7
 s.data.7.col = 2
 s.data.7.txt = 'G)eneral Info.:'
 s.data.7.fdw = 40

 s.data.8.row = 8
 s.data.8.col = 2
 s.data.8.txt = 'T)elephone....:'
 s.data.8.fdw = 40

 s.data.9.row = 9
 s.data.9.col = 2
 s.data.9.txt = 'U)ser Cost....:'
 s.data.9.fdw = 5

 s.data.10.row = 10
 s.data.10.col = 2
 s.data.10.txt = 'C)all Cost....:'
 s.data.10.fdw = 5

 s.data.11.row = 11
 s.data.11.col = 2
 s.data.11.txt = 'M)odem Type...:'
 s.data.11.fdw = 5

 s.data.12.row = 12
 s.data.12.col = 2
 /*s.data.12.txt = '@)Baud Rate...:'*/
 s.data.12.txt = '@)NodeFlags...:'
 s.data.12.fdw = 5

 s.bar.0     = 4
 i = 9
 j = 30
 s.bar.1.row = i
 s.bar.1.col = j+2
 s.bar.1.txt = 'Host Region'
 i = i + 1
 s.bar.2.row = i
 s.bar.2.col = j+1
 s.bar.2.txt = 'Hub | | Zone CM                Point'
 i = i + 1
 s.bar.3.row = i
 s.bar.3.col = j+3
 s.bar.3.txt = '| | | |    |                     |'
 i = i + 1
 s.bar.4.row = i
 s.bar.4.col = j+2
 s.bar.4.txt = '                                '
 


 call RxWinCenterText hWnd.1, 1, "RExx Bonk for OS/2", clr.Txt

 do i = 1 to s.data.0
    call RxWinSetCursorPos hWnd.1, s.data.i.row, s.data.i.col
    call RxWinTextOut      hWnd.1, s.data.i.txt, clr.Txt
 end
 do i = 1 to s.bar.0
    call RxWinSetCursorPos hWnd.1, s.bar.i.row, s.bar.i.col
    call RxWinTextOut      hWnd.1, s.bar.i.txt, clr.Txt
 end


 inp.row = 15
 inp.col = 20
 inp.wid = 50
 inp.msg.1 = 'Command (<Q>uit): '
 inp.msg.2 = 'Enter Addr: '
 inp.msg.3 = 'Enter Name: '
 
 call OutputPrompt  inp.msg.1

 rc = RxV7NLInit(config.v7dir,,,)
 data = RxV7NodeFind(config.addr)
 call DisplayNodeData data

 call DisplayOrder

 do until inp.key = 'q'
   call OutputPrompt inp.msg.1
   inp.key = SysGetKey('NOECHO')
   call RxWinTextOut hWnd.1, inp.key, clr.Txt
   select 
     when inp.key = '+' then
       do
          i = node.order
          call RxV7NLNext node.param.i, 'data'
          call DisplayNodeData data
       end
     when inp.key = '-' then
       do
       end
     when inp.key = 'a' then
       do
          call OutputPrompt inp.msg.2
          address = InputString(30)
          if address <> '' then
          do
             call RxV7NLFind 'N', address, 'data'
             if data <> '' then
                call DisplayNodeData data
          end
          
       end
     when inp.key = 'o' then
       do
          call OutputPrompt inp.msg.3
          /*inp.key = SysGetKey('NOECHO')*/
          name = InputString(30)
          if name <> '' then
          do
             call RxV7NLFind 'S', name, 'data'
             if data <> '' then
                call DisplayNodeData data
          end
          
       end
     when inp.key = 'n' then
       do
          if node.order == 1 then
             node.order = 2
          else
             node.order = 1
          call DisplayOrder
       end
     otherwise
       do
       end
   end      
 end
 
 call RxWinTerminate
 return

/*signal exit*/

/******************/
InputString: procedure expose hWnd. clr.
   arg length
   
   if length == '' then
      length = 40
      
   data = ''
   do i = 1 to length
      k = SysGetKey('NOECHO')
      if k == d2c(13) then leave
      data = data||k
      call RxWinTextOut hWnd.1, data, clr.Txt
   end
return  data;

OutputPrompt: procedure  expose hWnd. clr. inp.
 arg prompt 
 
 call RxWinSetCursorPos hWnd.1, inp.row, inp.col
 call RxWinTextOut      hWnd.1, left(prompt,inp.wid), clr.Txt
 call RxWinSetCursorPos hWnd.1, inp.row, inp.col+length(prompt)+1
return


DisplayOrder: procedure  expose hWnd. s. clr. node.
 
 call RxWinSetCursorPos hWnd.1, s.data.1.row, s.data.1.col+length(s.data.1.txt)
 i = node.order
 call RxWinTextOut      hWnd.1, left(node.order.i, s.data.1.fdw), clr.FWD
return



DisplayNodeData: procedure expose hWnd. clr. s. itm.
 arg str
 
 parse var str itm.2 ',' itm.5 ',' itm.6 ',' itm.7 ',' itm.8 ',' itm.4 ',' itm.10 ',' itm.9 ',' itm.11 ',' itm.12 ',' itm.3

 flags = itm.12
 itm.11 = x2d(itm.11)
 
 do i = 2 to s.data.0
    call RxWinSetCursorPos hWnd.1, s.data.i.row, s.data.i.col+length(s.data.i.txt)
    call RxWinTextOut      hWnd.1, left(itm.i, s.data.i.fdw), clr.FWD
 end
 
 call RxWinSetCursorPos hWnd.1, s.bar.4.row, s.bar.4.col
 call RxWinTextOut hWnd.1, MakeBar(flags), clr.FWD
return


MakeBar: procedure 
  arg flags
  
  i = right(flags,4,0)
  jj = 1
  str = ''
  do j = 1 to 16
     ii = right(d2x(jj),4,0)
     if bitand(i, ii) == ii then
        str = str||' O'
     else
        str = str||' .'
     if (j // 4) == 0 then
        str = str||'   '
     jj = jj * 2   
  end
  
return str;


LoadAllDlls: procedure

Say 'Loading Spectre8 dll' 
if RxFuncQuery('RxWinLoadFuncs') then
do
   call RxFuncAdd 'RxWinLoadFuncs', 'Spectre8', 'RxWinLoadFuncs'
   call RxWinLoadFuncs
end


Say 'Loading RxV7NL dll' 
if RxFuncQuery('RxV7NLVersion') then
do
   call RxFuncAdd 'RxV7NLVersion', 'RxV7NL', 'RxV7NLVersion'
   call RxFuncAdd 'RxV7NLInit',    'RxV7NL', 'RxV7NLInit'
   call RxFuncAdd 'RxV7NLTerm',    'RxV7NL', 'RxV7NLTerm'
   call RxFuncAdd 'RxV7NodeFind',  'RxV7NL', 'RxV7NodeFind'
   call RxFuncAdd 'RxV7NLFind',    'RxV7NL', 'RxV7NLFind'
   call RxFuncAdd 'RxV7NLNext',    'RxV7NL', 'RxV7NLNext'
end


/* check whether RxFuncs are loaded, if not, load them */
if RxFuncQuery('SysLoadFuncs') then
do
    /* load the load-function */
    call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'       

    /* load the Sys* utilities */
    call SysLoadFuncs                                                 
end
return


/****
call RxFuncAdd 'RxWinTerm', 'Spectre8', 'RxWinTerminate'
call RxFuncAdd 'RxWinClrScr', 'Spectre8', 'RxWinClearScreen'
call RxFuncAdd 'RxWinCreateWindow', 'Spectre8', 'RxWinCreateWindow'
call RxFuncAdd 'RxWinDestroyWindow', 'Spectre8', 'RxWinDestroyWindow'
call RxFuncAdd 'RxWinCenterText', 'Spectre8', 'RxWinCenterText'
call RxFuncAdd 'RxWinMoveWindow', 'Spectre8', 'RxWinMoveWindow'
**********/



FastExit:
 call RxWinTerminate
 say 'Screen size is smaller than 80,25'
 
exit:
